<?php

/*
 * danomac's changelog oct-2004
 *    -added autoBanByIP()
 * danomac's changelog 15-Nov-2003: 
 *    -changed the collectBytes() function to track peer uploads
 *    -changed the runSpeed() function to also computer the avf % done on torrent
 *    -added scrapeVerifyTorrent() -- checks to see if the hash requested is "hidden"
 *
 * Copyright (C) 2004 DeHackEd
 * Portions Copyright (C) 2004 danomac
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//////////////////////////////////////////////////////////////////
// Worker functions

/*
 * Bans the IP address indicated
 */
function autoBanByIP($ip, $iplong, $reason, $length) {
	$expiry = date("Y-m-d", time() + ($length * 86400));

	@mysql_query("INSERT INTO ipbans (ip, iplong, bandate, reason, autoban, banlength, banexpiry, banautoexpires) 
									VALUES (\"$ip\",
										$iplong, 
										\"". date("Y-m-d") ."\", 
										\"$reason\", 
										\"Y\", $length, \"$expiry\", \"Y\")");
}

// Uses the mysql database connection to perform string math. :)
// Used by byte counting functions
// No error handling as we assume nothing can go wrong. :|
function sqlAdd($left, $right)
{
	$query = 'SELECT '.$left.'+'.$right;
	$results = mysql_query($query) or showError("Database error.");
	$result = mysql_fetch_row($results);
	mysql_free_result($results);
	return $result[0];
}

// Ditto
function sqlSubtract($left, $right)
{
	$query = 'SELECT '.$left.'-'.$right;
	$results = mysql_query($query) or showError("Database error");
	$result = mysql_fetch_row($results);
	mysql_free_result($results);
	return $result[0];
}

function sqlDivide($left, $right)
{
	$query = 'SELECT '.$left.'/'.$right;
	$results = mysql_query($query) or showError("Database error");
	$result = mysql_fetch_row($results);
	mysql_free_result($results);
	return $result[0];
}

function sqlMultiply($left, $right)
{
	$query = 'SELECT '.$left.'*'.$right;
	$results = mysql_query($query) or showError("Database error");
	$result = mysql_fetch_row($results);
	mysql_free_result($results);
	return $result[0];
}


// Runs a query with no regard for the result
function quickQuery($query)
{
	$results = @mysql_query($query);
	if (!is_bool($results))
		mysql_free_result($results);
	else
		return $results;
	return true;
}

// Reports an error to the client in $message.
// Any other output will confuse the client, so please don't do that.
function showError($message, $log=false)
{
  if ($log)
	  error_log("PHPBTTracker: Sent error ($message)");
  echo "d14:failure reason".strlen($message).":$message"."e";
  exit;
}


// From the PHP web site user comments, and fixed to prevent PHP warnings.
function hex2bin($hexdata) {
  $bindata = ""; 
  for ($i=0;$i<strlen($hexdata);$i+=2) {
    $bindata.=chr(hexdec(substr($hexdata,$i,2)));
  }
 
  return $bindata;
}



// Used by newtorrents.php and the dynamic_torrents setting
// Returns true/false, depending on if there were errors.
function makeTorrent($hash, $tolerate = false)
{
	if (strlen($hash) != 40) 
		showError("makeTorrent: Received an invalid hash");
	
	$result = true;
	$query = "CREATE TABLE x$hash (peer_id char(40), 
				bytes bigint NOT NULL default 0, 
				ip varchar(50) NOT NULL default \"error.x\", 
				port varchar(5) NOT NULL default \"0\", 
				status enum('leecher','seeder') NOT NULL, 
				lastupdate bigint NOT NULL default 0, 
				sequence bigint AUTO_INCREMENT NOT NULL, 
				natuser enum('N', 'Y') not null default 'N', 
				uploaded bigint NOT NULL default 0, 
				clientversion varchar(250) default \"\", primary key(sequence), unique(peer_id))";
	if (!@mysql_query($query))
		$result = false;
	if (!$result && !$tolerate)
		return false;
	$query = "INSERT INTO summary set info_hash=\"".$hash."\", lastSpeedCycle=".time();
	if (!@mysql_query($query))
		$result = false;
	return $result;
}

// Returns true if the torrent exists.
// Currently checks by locating the row in "summary"
// Always returns true if $dynamic_torrents=="1" unless an error occured
function verifyTorrent($hash)
{
	$query = "SELECT info_hash FROM summary where info_hash=\"$hash\"";
	$results = mysql_query($query);
	
	$row = mysql_fetch_row($results);
	
	if ($row)
		return true;
	
	if ($GLOBALS["dynamic_torrents"])
		return makeTorrent($hash);

	return false;
}


// Verifies a hash is valid
function verifyHash($hash)
{
	if (strlen($hash) != 40)
		return false;
	$hash = strtolower($hash);
	for ($i = 0; $i < strlen($hash); $i++)
	{
		if ($hash[$i] >= '0' && $hash[$i] <= '9')
			continue;
		if ($hash[$i] >= 'a' && $hash[$i] <= 'f')
			continue;
		break;
	}
	if ($i != 40)
		return false;
	return true;
}

// for the scrape function: return true if the hash is NOT hidden, false if we aren't gonna send info! :-)
function scrapeVerifyHash($hash)
{
        $query = mysql_query("SELECT info_hash, hide_torrent FROM summary WHERE info_hash=\"$hash\"");
	$row = mysql_fetch_row($query);
	
	if (!$row) return false;	
	
	//if it's hidden return false.
	if ($row[1]=="Y") return false;

	//nothing to hide here!
	return true;
}

// Returns info on one peer
function getPeerInfo($user, $hash)
{
	// If "trackerid" is set, let's try that
	
	if (isset($GLOBALS["trackerid"]))
	{
		$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence FROM x$hash WHERE sequence=${GLOBALS["trackerid"]}";
		$results = mysql_query($query) or showError("Tracker error: invalid torrent");
		$data = mysql_fetch_row($results);
		if (!$data)
			return false;
		if ($data[0] != $user)
		{
			// Damn, but don't crash just yet.
			$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence from x$hash where peer_id=\"$user\"";
			$results = mysql_query($query) or showError("Tracker error: invalid torrent"); 
			$data = mysql_fetch_row($results);
		}
	}
	else
	{
		$query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence from x$hash where peer_id=\"$user\"";
		$results = mysql_query($query) or showError("Tracker error: invalid torrent");
		$data = mysql_fetch_row($results);

	}
	
	if (!($data))
		return false;
	
	$return["peer_id"] = $data[0];
	$return["bytes"] = $data[1];
	$return["ip"] = $data[2];
	$return["port"]=$data[3];
	$return["status"] = $data[4];
	$return["lastupdate"] = $data[5];
	$return["trackerid"] = $data[6];
	return $return;
}

// Loads all peers into one large bulk, returns false on error
// This has been depreciated and may be deleted soon.
function loadPeers($hash, $rules = "")
{
	$peerno = 0;
	$query = "SELECT peer_id,bytes,ip,port,status,lastupdate from x$hash";
	$results = mysql_query($query);
	if (!$results)
		return false;
	while ($data = mysql_fetch_row($results))
	{
		$return[$peerno]["peer_id"] = $data[0];
		$return[$peerno]["bytes"] = $data[1];
		$return[$peerno]["ip"] = $data[2];
		$return[$peerno]["port"]=$data[3];
		$return[$peerno]["status"] = $data[4];
		$return[$peerno]["lastupdate"] = $data[5];
		$peerno++;	
	}
	$return["size"] = $peerno;
	mysql_free_result($results);
	return $return;
}

// Slight redesign of loadPeers
function getRandomPeers($hash, $where="")
{
	$peerno = 0;
	// Don't want to send a bad "num peers" for new seeds

	if ($GLOBALS["NAT"])
		$results = mysql_query("SELECT COUNT(*) FROM x$hash WHERE natuser = 'N'");
	else
		$results = mysql_query("SELECT COUNT(*) FROM x$hash");

	$data = mysql_fetch_row($results) or showError("Internal tracker error on getRandomPeers");
	$peercount = (int) $data[0];

	//	Excessive, and not really necessary
//	$results = mysql_query("SELECT COUNT(*) FROM x$hash WHERE natuser = 'N' AND status='seeder'");
//	$data = mysql_fetch_row($results);
//	$seedcount = (int) $data[0];

	$max = $GLOBALS["maxpeers"];

	if ($peercount < $max)
		$random = 0;
	else
		$random = @mt_rand(0, $peercount - $max);

	// ORDER BY RAND() is expensive. Don't do it when the load gets too high
	if ($peercount < 300)
		$query = "SELECT peer_id,bytes,ip,port,status,lastupdate FROM x$hash ".$where." ORDER BY RAND() LIMIT $max";
	else
		$query = "SELECT peer_id,bytes,ip,port,status,lastupdate FROM x$hash LIMIT $random, $max";


	$results = mysql_query($query);
	if (!$results)
		return false;
	while ($data = mysql_fetch_row($results))
	{
		$return[$peerno]["peer_id"] = $data[0];
		$return[$peerno]["bytes"] = $data[1];
		$return[$peerno]["ip"] = $data[2];
		$return[$peerno]["port"]=$data[3];
		$return[$peerno]["status"] = $data[4];
		$return[$peerno]["lastupdate"] = $data[5];
		$peerno++;	
	}
	$return["size"] = $peerno;
	$resultcount = mysql_num_rows($results);
	
	$query = mysql_query("SELECT MAX(sequence) FROM x$hash") or showError("Database error");
	$maxsequence = mysql_fetch_row($query); // assume it works
	$return["last"] = $maxsequence[0];
	$return["num peers"] = $peercount;
//	$return["num seeds"] = $seedcount;
	mysql_free_result($results);
	return $return;
}

// Deletes a peer from the system and performs all cleaning up
function killPeer($userid, $hash, $left)
{
	if (isset($GLOBALS["trackerid"]))
		unset($GLOBALS["trackerid"]);
	$peer = getPeerInfo($userid, $hash);
	$bytes = sqlSubtract($peer["bytes"], $left);

	quickQuery("DELETE FROM x$hash WHERE peer_id=\"$userid\"");
	if (mysql_affected_rows() == 1)
	{
		if (strcmp($peer["status"], "leecher") == 0)
			quickQuery("UPDATE summary SET leechers=leechers-1 WHERE info_hash=\"$hash\"");
		else if (strcmp($peer["status"], "seeder") == 0)
			quickQuery("UPDATE summary SET seeds=seeds-1 WHERE info_hash=\"$hash\"");
		if (((float)$bytes) > 0)
			quickQuery("UPDATE summary SET dlbytes=dlbytes + $bytes WHERE info_hash=\"$hash\"");
		if ($peer["bytes"] != 0 && $left == 0)
			quickQuery("UPDATE summary SET finished=finished+1 WHERE info_hash=\"$hash\"");
	}
}

// Updates the peer user's info.
// Currently it only updates the "lastupdate" value
function updatePeer($peerid, $hash)
{
	$now = $GLOBALS["time"];
	quickQuery("UPDATE x$hash set lastupdate=$now where peer_id=\"$peerid\"");
}


// Transfers bytes from "left" to "dlbytes" when a peer reports in.
function collectBytes($peer, $hash, $left, $uploaded)
{
	/*
	 * modified to update the tables with the amount of bytes a peer has "contributed" to the torrent
         */

	$diff = sqlSubtract($peer["bytes"], $left);
	$peerid=$peer["peer_id"];

	// Anti-negative clause
	if (((float)$diff) > 0)
		quickQuery("UPDATE summary SET dlbytes=dlbytes+$diff WHERE info_hash=\"$hash\"");
	quickQuery("UPDATE x$hash set bytes=\"$left\", uploaded=$uploaded where peer_id=\"$peerid\"");
}

// Transmits the actual data to the peer. No other output is permitted if
// this function is called, as that would break BEncoding.
// I don't use the bencode library, so watch out! If you add data,
// rules such as dictionary sorting are enforced by the remote side, so watch out.
function sendPeerList($peers)
{
	echo "d";
  	if (isset($peers["num seeds"]))
  	        echo "10:done peersi".$peers["num seeds"]."e";


  	echo "8:intervali".$GLOBALS["report_interval"]."e";


        if (isset($peers["last"]) && $GLOBALS["maxpeers"] == $peers["size"])
 		echo "4:lasti".$peers["last"]."e";


	if (isset($GLOBALS["min_interval"]))
		echo "12:min intervali".$GLOBALS["min_interval"]."e";
	if (isset($peers["num peers"]))
		echo "9:num peersi".$peers["num peers"]."e";

	echo "5:peersl";
	$size=$peers["size"];
	for ($i=0; $i < $size; $i++)
	{
		// bencoding can kiss my butt for now. See BEncode.php
		$peerid = hex2bin($peers[$i]["peer_id"]);
		echo "d2:ip".strlen($peers[$i]["ip"]).":".$peers[$i]["ip"]."7:peer id".strlen($peerid).":".$peerid."4:porti".$peers[$i]["port"]."ee";
	}
	echo "e";
	
	if (isset($GLOBALS["trackerid"]))
	{
		// Now it gets annoying. trackerid is a string
		$trackerid = (string)$GLOBALS["trackerid"];
		echo "10:tracker id".strlen($trackerid).":$trackerid";

	}

	echo "e";
}

// Returns a $peers array of all peers that have timed out (2* report interval seems fair
// for any reasonable report interval (900 or larger))
function loadLostPeers($hash, $now, $timeout)
{
	$results = mysql_query("SELECT peer_id,bytes,ip,port,status,lastupdate from x$hash where lastupdate < ($now - 2 * $timeout)");
	$peerno = 0;
	if (!$results)
		return false;
	while ($data = mysql_fetch_row($results))
	{
		$return[$peerno]["peer_id"] = $data[0];
		$return[$peerno]["bytes"] = $data[1];
		$return[$peerno]["ip"] = $data[2];
		$return[$peerno]["port"]=$data[3];
		$return[$peerno]["status"] = $data[4];
		$return[$peerno]["lastupdate"] = $data[5];
		$peerno++;	
	}
	$return["size"] = $peerno;
	mysql_free_result($results);
	return $return;
}

function trashCollector($hash, $timeout, $now)
{
	if (!Lock($hash))
		return;
	
	$results = mysql_query("SELECT lastcycle FROM summary WHERE info_hash='$hash'");
	$lastcheck = (mysql_fetch_row($results));
	
	// Check once every re-announce cycle
	if (($lastcheck[0] + $timeout) < $now)
	{
		$peers = loadLostPeers($hash, $now, $timeout);
		for ($i=0; $i < $peers["size"]; $i++)
			killPeer($peers[$i]["peer_id"], $hash, $peers[$i]["bytes"]);
		quickQuery("UPDATE summary SET lastcycle='$now' WHERE info_hash='$hash'");
	}
	Unlock($hash);
}

// Attempts to aquire a lock by name.
// Returns true on success, false on failure
function Lock($hash, $time = 0)
{
	$results = mysql_query("SELECT GET_LOCK('$hash', $time)");
	$string = mysql_fetch_row($results);
	if (strcmp($string[0], "1") == 0)
		return true;
	return false;

}

// Releases a lock. Ignores errors.
function Unlock($hash)
{
	quickQuery("SELECT RELEASE_LOCK('$hash')");
}

// Returns true if the lock is available
function isFreeLock($lock)
{
	if (Lock($lock, 0))
	{
		Unlock($lock);
		return true;
	}
	return false;
}


/* Returns true if the user is firewalled, NAT'd, or whatever.
 * The original tracker had its --nat_check parameter, so
 * here is my version.
 *
 * This code has proven itself to be sufficiently correct,
 * but will consume system resources when a lot of httpd processes
 * are lingering around trying to connect to remote hosts.
 * Consider disabling it under higher loads.
 */
function isFireWalled($hash, $peerid, $ip, $port)
{

	// NAT checking off?
	if (!$GLOBALS["NAT"])
		return false;


	

	$protocol_name = 'BitTorrent protocol';
	$theError = "";
	// Hoping 10 seconds will be enough
	$fd = fsockopen($ip, $port, $errno, $theError, 10);
	if (!$fd)
		return true;

	stream_set_timeout($fd, 5, 0);
	fwrite($fd, chr(strlen($protocol_name)).$protocol_name.hex2bin("0000000000000000").
		hex2bin($hash));
	
	$data = fread($fd, strlen($protocol_name)+1+20+20+8); // ideally...

	fclose($fd);
	$offset = 0;

	// First byte: strlen($protocol_name), then the protocol string itself
	if (ord($data[$offset]) != strlen($protocol_name))
		return true;

	$offset++;
	if (substr($data, $offset, strlen($protocol_name)) != $protocol_name)
		return true;

	$offset += strlen($protocol_name);
	// 8 bytes reserved, ignore
	$offset += 8;
	
	// Download ID (hash)
	if (substr($data, $offset, 20) != hex2bin($hash))
		return true;

	$offset+=20;
	
	// Peer ID
	if (substr($data, $offset, 20) != hex2bin($peerid))
		return true;

	
	return false;
}


// It's cruel, but if people abuse my tracker, I just might do it.
// It pretends to accept the torrent, and reports that you are the
// only person connected.
function evilReject($ip, $peer_id, $port)
{

	// For those of you who are feeling evil, comment out this line.
	showError("Torrent is not authorized for use on this tracker.");

	$peers[0]["peer_id"] = $peer_id;
	$peers[0]["ip"] = $ip;
	$peers[0]["port"] = $port;
	$peers["size"] = 1;
	$GLOBALS["report_interval"] = 86400;
	$GLOBALS["min_interval"] = 86000;
	sendPeerList($peers);
	exit(0);
}


function runSpeed($info_hash, $delta)
{

	/*
    * changed from the original, this now also computes the average % done on the torrent
    */

	// Start by grabbing the data we need.
	$results = mysql_query("SELECT dlbytes FROM summary WHERE info_hash=\"$info_hash\"");
	$dlbytes = mysql_fetch_row($results);
	$dlbytes = $dlbytes[0];
	quickQuery("INSERT INTO timestamps SET info_hash=\"$info_hash\", bytes=$dlbytes, delta=$delta");

	// Read in the speed columns
	$results = mysql_query("SELECT bytes, delta, sequence FROM timestamps WHERE info_hash=\"$info_hash\" ORDER BY sequence");
	$rowcount = mysql_num_rows($results);
	$summ = 0;
	for ($i=0; $i < $rowcount; $i++)
	{
		$row[$i] = mysql_fetch_row($results);
		$summ += $row[$i][1];
	}
	$bytedifference = sqlSubtract($row[$rowcount-1][0], $row[0][0]);

	// Make database changes
	if ($summ == 0)
		quickQuery("UPDATE summary SET speed=-1 WHERE info_hash=\"$info_hash\"");
	else
		quickQuery("UPDATE summary SET speed=$bytedifference / $summ WHERE info_hash=\"$info_hash\"");
	if ($rowcount > 20)
		quickQuery("DELETE FROM timestamps WHERE sequence=".$row[0][2]);
}

function runAvg($info_hash)
{
	// start to get the data needed to compute avg % done
	//get file size (in MiB)
	$queryresults = mysql_query("SELECT size FROM namemap WHERE info_hash=\"$info_hash\"");
	$file_size_MiB = mysql_fetch_row($queryresults);
	$file_size_MiB = $file_size_MiB[0];

	//get the average done from the database to compare calculation with
	$queryresults = mysql_query("SELECT avgdone FROM summary WHERE info_hash=\"$info_hash\"");
	$storedavgdone = mysql_fetch_row($queryresults);
	$storedavgdone = $storedavgdone[0];

	//..and get the average # of bytes left
	$queryresults = mysql_query("SELECT peer_id, bytes FROM x$info_hash WHERE status=\"leecher\"");
	$rowcountavg = mysql_num_rows($queryresults);

	$avgcompute=0;

	//well, the avg() function was producing some odd results... let's try it manually
	for ($i=0; $i < $rowcountavg; $i++) {
		$rowavg = mysql_fetch_row($queryresults);
		$avgcompute += $rowavg[1];
	}

	$avgcompute = round(($avgcompute / $rowcountavg) / 1048576, 2);

	//make sure the file size is valid, then compute...
	if ($file_size_MiB==0) {
		// error, possible div/0 runtime error
		$avgdone = 0;
	} else {
		//ok, compute (in MiB)
		$avgdone = round(100 - (($avgcompute / $file_size_MiB) * 100), 2);
	}

	//eh, if it's 100%, that usually means no leechers are present, so set to 0...
	if ($avgdone == 100.0) $avgdone = 0;

	// Make database changes if needed
	if ($storedavgdone != $avgdone) 
		quickQuery("UPDATE summary SET avgdone=$avgdone WHERE info_hash=\"$info_hash\"");
}

// Even if you're missing PHP 4.3.0, the MHASH extension might be of use.
// Someone was kind enought to email this code snippit in.
if (function_exists('mhash') && (!function_exists('sha1')) && 
defined('MHASH_SHA1'))
{
  function sha1($str)
                {
      return bin2hex(mhash(MHASH_SHA1,$str));
                }
}

/*
 * Used by consistencyCheck(), checks and removes stale peers
 *
 * Added: 30Mar04
 */
function checkForStalePeers($hash, $timeout, $now, $cellBG, $outputHTML) {
	/*
	 * Get the list of stale peers
	 */
 	$peers = loadLostPeers($hash, $now, $timeout);

	/*
	 * Go through the list, removing them
	 */
	for ($i=0; $i < $peers["size"]; $i++)
     killPeer($peers[$i]["peer_id"], $hash, $peers[$i]["bytes"]);

	/*
	 * If output is enabled, indicate result
	 */
	if ($outputHTML) {
		if ($i != 0)
			echo "\t<TD CLASS=\"consistency\">Removed $i</TD>\r\n";
		else
			echo "\t<TD $cellBG>Removed 0</TD>\r\n";
	}

	/*
	 * Set the timestamp in the summary table
	 */
 	quickQuery("UPDATE summary SET lastcycle='$now' WHERE info_hash='$hash'");
}

function consistencyCheck($outputHTML = false) {
	/*
	 * These are the alternating Cascadying Style Sheet classes used for the data.
	 */
	$classRowBGClr[0] = 'CLASS="odd"';
	$classRowBGClr[1] = 'CLASS="even"';

	/*
	 * Check to see if no locking was requested.
	 */
	if (isset($_GET["nolock"]))
		$locking = false;
	else
		$locking = true;

	/*
	 * Grab the info needed from the database.
	 */
	$query = "SELECT summary.info_hash, 
					namemap.filename, 
					namemap.size, 
					summary.seeds, 
					summary.leechers, 
					summary.dlbytes, 
					format(summary.avgdone, 1),
					summary.speed,
					summary.external_torrent
					FROM summary 
					LEFT JOIN namemap ON summary.info_hash = namemap.info_hash WHERE summary.external_torrent=\"N\"
					ORDER BY namemap.filename";

	$recordset = mysql_query($query) or die("Database reported this error: ".mysql_error());

	/*
	 * Lock the tables, if requested
	 */
	if ($locking)
		quickQuery("LOCK TABLES summary WRITE");

	/*
	 * Outputting HTML is optional, specified by the
	 * parameter. If it is NOT specified, assumes DON'T
	 * output any HTML.
	 * The HTML itself is inserted into it's own table.
	 */
	if ($outputHTML) {
		echo "<TABLE CLASS=\"tblAdminOuter\">\r\n";
		echo "<TR>\r\n\t<TD CLASS=\"heading\">Name/Info Hash</TD>\r\n";
		echo "\t<TD CLASS=\"heading\" ALIGN=\"center\">Size<BR>(MiB)</TD>\r\n";
		echo "\t<TD CLASS=\"heading\" ALIGN=\"center\">UL</TD>\r\n";
		echo "\t<TD CLASS=\"heading\" ALIGN=\"center\">DL</TD>\r\n";
		echo "\t<TD CLASS=\"heading\" ALIGN=\"center\">XFER<BR>(GiB)</TD>\r\n";
		echo "\t<TD CLASS=\"heading\" ALIGN=\"center\">Speed<BR>(KiB/sec)</TD>\r\n";
		echo "\t<TD CLASS=\"heading\" ALIGN=\"center\">Avg %<BR>Done</TD>\r\n";
		echo "\t<TD CLASS=\"heading\">Stale clients</TD>\r\n</TR>";
	}

	/*
	 * Counter used for alternating row BGCOLOR.
	 */
	$i = 0;

	/*
	 * Go throught the recordset, and analyze each torrent
	 */
	while ($row = mysql_fetch_row($recordset)) {
		/*
		 * If it's an external source, ignore it...
		 */
		if ($row[8]=='N') {
			/*
			 * Calculate which background colour to use
			 */
			$cellBG = $classRowBGClr[$i % 2];

			/*
			 * Extract information from the data row
			 */
			$hash = $row[0];
			$seeders = $row[3];
			$leechers = $row[4];
			$bytes = $row[5];
			$avgdone = $row[6];
			$speed = $row[7];

			/*
			 * Lock the tables, if requested
			 */
			if ($locking)
				quickQuery("LOCK TABLES x$hash WRITE, summary WRITE");

			/*
			 * If HTML output is desired, then output filename
			 * and the torrent size
			 */
			if ($outputHTML) {
				echo "<TR>\r\n\t<TD $cellBG>";

				/*
				 * If there is no filename use the hash value.
				 */
				if (strlen($row[1]) > 0)
					echo $row[1];
				else
					echo $hash;

				echo "</TD>\r\n";
				
				echo "\t<TD $cellBG ALIGN=\"center\">$row[2]</TD>\r\n";
			}

			/*
			 * Check to make sure the seeder count is accurate.
			 */
			$count = mysql_query("SELECT COUNT(*) from x$hash WHERE status=\"seeder\"");

			if ($count) {
				$seedcount = @mysql_fetch_row($count);

				if ($seedcount[0] != $seeders) {
					quickQuery("UPDATE summary SET seeds=".$seedcount[0]." WHERE info_hash=\"$hash\"");
					if ($outputHTML) echo "\t<TD CLASS=\"consistency\" ALIGN=\"center\">$seeders -> ".$seedcount[0]."</TD>\r\n";
				} else
					if ($outputHTML) echo "\t<TD $cellBG ALIGN=\"center\">$seeders</TD>\r\n";
			} else {
				quickQuery("UPDATE summary SET seeds=0 WHERE info_hash=\"$hash\"");
			}

			/*
			 * Check to make sure the leecher count is accurate.
			 */
			$count = mysql_query("SELECT COUNT(*) from x$hash WHERE status=\"leecher\"");

			if ($count) {
				$leechcount = @mysql_fetch_row($count);
	
				if ($leechcount[0] != $leechers)	{
					quickQuery("UPDATE summary SET leechers=".$leechcount[0]." WHERE info_hash=\"$hash\"");
					if ($outputHTML) echo "\t<TD CLASS=\"consistency\" ALIGN=\"center\">$leechers -> ".$leechcount[0]."</TD>\r\n";
				} else
					if ($outputHTML) echo "\t<TD $cellBG ALIGN=\"center\">$leechers</TD>\r\n";
			} else {
					quickQuery("UPDATE summary SET leechers=0 WHERE info_hash=\"$hash\"");
			}

			/*
			 * Make sure bytes downloaded is accurate (above zero, in this case)
			 */
			if ($bytes < 0) {
				quickQuery("UPDATE summary SET dlbytes=0 WHERE info_hash=\"$hash\"");
				if ($outputHTML) echo "\t<TD CLASS=\"consistency\" ALIGN=\"center\">$bytes -> Zero</TD>\r\n";
			} else
				if ($outputHTML) echo "\t<TD $cellBG ALIGN=\"center\">". round($bytes/1073741824,1) ."</TD>\r\n";

			/*
			 * Check the speed of the torrent
			 * If leechers is zero and the speed is above 0, correct it
			 */
			if (($leechcount[0]==0 and $speed <> 0)) {
				quickQuery("UPDATE summary SET speed=0 WHERE info_hash=\"$hash\"");
				if ($outputHTML) echo "\t<TD CLASS=\"consistency\" ALIGN=\"center\">". round($speed/1024,1) . " -> 0</TD>\r\n";
			} else	
				if ($outputHTML) echo "\t<TD $cellBG ALIGN=\"center\">" . round($speed/1024,1) . "</TD>\r\n";

			/*
			 * Check the average percentage done on the torrent
			 * If leechers is zero or torrent is inactive, and there is a value besides zero, correct it
			 * Also, if it is invalid (<0 or >100) reset it
			 */
			if (($leechcount[0]==0 and $avgdone <> 0) or ($avgdone > 100 or $avgdone < 0)) {
				quickQuery("UPDATE summary SET avgdone=0 WHERE info_hash=\"$hash\"");
				if ($outputHTML) echo "\t<TD CLASS=\"consistency\" ALIGN=\"center\">$avgdone -> 0.0%</TD>\r\n";
			} else	
				if ($outputHTML) echo "\t<TD $cellBG ALIGN=\"center\">" . $avgdone . "%" . "</TD>\r\n";

			/*
			 * Check to see if there are peers that have expired and
			 * need to be removed
			 */
			checkForStalePeers($hash, $GLOBALS['report_interval'], time(), $cellBG, $outputHTML);

			if ($outputHTML) echo "</TR>\r\n";

			/*
			 * Increment the counter for the alternating of BG colours
			 */
			$i ++;

			/*
			 * Optimize the hash table that contains seeder/leecher info
			 */
			quickQuery("OPTIMIZE TABLE x$hash");

			/*
			 * Unlock the tables, if they were locked.
			 */
			if ($locking)
				quickQuery("UNLOCK TABLES");
		}
	}

	if ($outputHTML) echo "</TABLE>\r\n";
}

/*
 * Checks to see if a string IP address is valid.
 *
 * Added: 5-Apr-2004
 */
function checkIP($ip) {
		$iparray = explode(".", $ip);
		if (count($iparray) != 4)
			return false;

		if (!is_numeric($iparray[0]) ||
			!is_numeric($iparray[1]) ||
			!is_numeric($iparray[2]) ||
			!is_numeric($iparray[3]))
			return false;

		foreach ($iparray as $ipnum) {
			if ($ipnum > 255 || $ipnum < 0)
				return false;
		}
		return true;
}

?>
